const outputFile = 'jobs-special', RssBraider = require('rss-braider'), fs = require('fs'), ejs = require(
    'ejs'), read = require('fs').readFileSync, join = require('path').join, str = read(
    join(__dirname, '/templates/rss.ejs'),
    'utf8'), feeds = {};

const argv = require('yargs').argv;

const log4js = require('log4js');
const logger = log4js.getLogger();

// Pull feeds from config files: ,
//      feeds.simple_test_feed = require("./config/feed").feed;
// Or define in-line

feeds.simple_test_feed = {
  "feed_name": "feed",
  "default_count": 1,
  "no_cdata_fields": ['description'], // Don't wrap these fields in CDATA tags
  "meta": {
    "title": "Jobs",
    "description": "Combined Jobs Feed",
    'site_url': 'http://pipes.silvrtree.co.uk/jobs-new.xml'
  },
  "plugins": [
    'filter_location', 'filter_reject', 'filter_md_jobs', 'filter_today_only'
  ],
  'custom_namespaces'   : {
    "content"   : "http://purl.org/rss/1.0/modules/content/",
    "slash"     : "http://purl.org/rss/1.0/modules/slash/",
    "media"     : "http://search.yahoo.com/mrss/",
    "ev"        : "http://purl.org/rss/2.0/modules/event/",
    "sy"        : "http://purl.org/rss/1.0/modules/syndication/",
    "wfw"       : "http://wellformedweb.org/CommentAPI/",
    "dc"        : "http://purl.org/dc/elements/1.1/",
    "atom"      : "http://www.w3.org/2005/Atom"
  },
  "sources": [

    {

      "count": 100,
      "feed_url": "http://www.jobserve.com/MySearch/6DA9769BA89834AA.rss"
    },
    {

      "count": 100,
      "feed_url": "http://www.JobServe.com/MySearch/EDF47BEA6B31EF.rss"
    },
    {

      "count": 100,
      "feed_url": "http://www.JobServe.com/MySearch/3CAD044BEF2BFA.rss"
    },
    {

      "count": 100,
      "feed_url": "http://www.JobServe.com/MySearch/C7B25D86D0844A.rss"
    },
    {

      "count": 100,
      "feed_url": "http://www.JobServe.com/MySearch/64A3EEF615FA4C.rss"
    },
    {

      "count": 100,
      "feed_url": "http://www.s1jobs.com/xml/m7dp711z2r.xml"
    },
    {

      "count": 100,
      "feed_url": "http://www.s1jobs.com/xml/pfvf7o7z2r.xml"
    },
    {

      "count": 100,
      "feed_url": "http://www.s1jobs.com/xml/lluqnt8z2r.xml"
    },
    {

      "count": 100,
      "feed_url": "http://www.s1jobs.com/xml/tu33qt8z2r.xml"
    },
    {

      "count": 100,
      "feed_url": "http://www.s1jobs.com/xml/u3btnz8z2r.xml"
    },
    {

      "count": 100,
      "feed_url": "http://www.s1jobs.com/xml/b1d7e6c3a9a11964z3r.xml"
    },
    {

      "count": 100,
      "feed_url": "http://www.s1jobs.com/xml/b1d7e6c3a9a11964z3r.xml"
    },
    {

      "count": 100,
      "feed_url": "http://www.jobserve.com/MySearch/CA49421A86CA3F74.rss"
    },
    {

      "count": 100,
      "feed_url": "http://www.s1jobs.com/xml/ddeded091b6f6d33z3r.xml"
    },
    {

      "count": 100,
      "feed_url": "http://www.s1jobs.com/xml/3eafc1ea20f1ca02z3r.xml"
    }
  ]
}

;
let braider_options = {
  feeds: feeds,
  indent: "    ",
  date_sort_order: "desc", // Newest first
  log_level: "debug",
  dedupe_fields: ['link', 'guid'],
  plugins_directories: [__dirname + "/plugins/"]
};
const rss_braider = RssBraider.createClient(braider_options);

// Override logging level (debug, info, warn, err, off)
//rss_braider.logger.level('off');

rss_braider.processFeed('simple_test_feed', 'rss', function(err, data) {
  if (err) {
    return console.log(err);
  }
  console.log('Saving', __dirname + "/dist/" + outputFile + ".xml");
  fs.writeFile(__dirname + "/dist/" + outputFile + ".xml", data, function(err) {
    if (err) {
      return console.log(err);
    }

    console.log("The file was saved!");
  });
});
